/* --------------------------------------------------------------------------
$Id: write_vhlhdf.h,v 1.2 2004/03/18 11:53:50 ahenja Exp $
Program:        

Description:    Functions for writing an HDF5 file with the HighLevel
		protocol.

Author(s):      Anders Henja

Copyright:	Swedish Meteorological and Hydrological Institute, 2000

History:
$Log: write_vhlhdf.h,v $
Revision 1.2  2004/03/18 11:53:50  ahenja
Modified with support for szip, also changed so that it is possible
to specify HL_FileCreationProperty when creating a file. Also changed
how the compression handling is working. Added a nicer way to
perform debugging and error handling. Now it is possible to define
an own error handler and hook it into the system, if this is done
all error messages will be sent to the given function.

Revision 1.1.1.1  2001/12/14 12:02:41  ahenja
First CVS version of hlhdf

Revision 1.5  2001/12/07 13:20:32  ahenja
Updated with possibilities to read and write references.

Revision 1.4  2001/11/09 08:30:56  ahenja
Updated with possibility to write references, unfortunately i havent got the time to implement read support.

Revision 1.3  2000/03/22 08:43:06  ahenja
Updated with spell checking and header information.

-----------------------------------------------------------------------------*/
#ifndef WRITE_HL_H
#define WRITE_HL_H

#include "vhlhdf.h"

int doWriteHdf5Attribute(hid_t rootGrp, HL_Node* parentNode, char* parentName,
			 HL_Node* childNode, char* childName);
int doWriteHdf5Group(hid_t rootGrp, HL_Node* parentNode, char* parentName,
		     HL_Node* childNode, char* childName);

int doWriteHdf5Dataset(hid_t rootGrp, HL_Node* parentNode, char* parentName,
		       HL_Node* childNode, char* childName, int doCompress);

int doWriteHdf5HLDataset(hid_t rootGrp, HL_Node* parentNode, char* parentName,
			 HL_Node* childNode, char* childName, HL_Compression* compression);

int doCommitHdf5Datatype(hid_t loc_id, HL_Node* parentNode, char* parentName,
			 HL_Node* childNode, char* childName);
int doWriteHdf5Reference(hid_t rootGrp, hid_t file_id,HL_Node* parentNode, char* parentName,
			 HL_Node* childNode, char* childName);

int writeHL_NodeList(HL_NodeList* nodelist, HL_FileCreationProperty* property, HL_Compression* compr);
int writeNodeList(HL_NodeList* nodelist, int doCompress);

#endif
