import _pyhl
from Numeric import *
import random

def get_nodelist_base():
    a=_pyhl.nodelist()

#    b=_pyhl.node(_pyhl.GROUP_ID,"/info")
#    a.addNode(b)

#    b=_pyhl.node(_pyhl.ATTRIBUTE_ID,"/info/xscale")
#    b.setScalarValue(-1,10.0,"double",-1)
#    a.addNode(b)

#    b=_pyhl.node(_pyhl.ATTRIBUTE_ID,"/info/yscale")
#    b.setScalarValue(-1,19.0,"double",-1)
#    a.addNode(b);

#    b=_pyhl.node(_pyhl.ATTRIBUTE_ID,"/info/xsize")
#    b.setScalarValue(-1,15,"int",-1)
#    a.addNode(b)

#    b=_pyhl.node(_pyhl.ATTRIBUTE_ID,"/info/ysize")
#    b.setScalarValue(-1,20,"int",-1)
#    a.addNode(b)

#    b=_pyhl.node(_pyhl.ATTRIBUTE_ID,"/info/pcs_def")
#    b.setScalarValue(-1,"min strang funktion verkar fungera","string",-1)
#    a.addNode(b)

    #c=arange(500*500)
    c=zeros((500,500),'i')
    for i in range(0,500):
        for j in range(0,500):
            c[i][j]=int(random.random()*100000)
    c=array(c.astype('i'),'i')
    c=reshape(c,(500,500))

    return (a,c)

def generate_szlib_compritem_nodelist():
    a,c = get_nodelist_base()
    szcompr = _pyhl.compression(_pyhl.COMPRESSION_SZLIB)
    szcompr.szlib_px_per_block = 10
    b=_pyhl.node(_pyhl.DATASET_ID,"/data",szcompr)
    b.setArrayValue(1,[500,500],c,"int",-1)
    a.addNode(b)
    return a

def generate_zlib_compritem_nodelist():
    a,c = get_nodelist_base()
    zcompr = _pyhl.compression(_pyhl.COMPRESSION_ZLIB)
    zcompr.level = 6
    b=_pyhl.node(_pyhl.DATASET_ID,"/data",zcompr)
    b.setArrayValue(1,[500,500],c,"int",-1)
    a.addNode(b)
    return a

def generate_notcompritem_nodelist():
    a,c = get_nodelist_base()
    b=_pyhl.node(_pyhl.DATASET_ID,"/data")
    b.setArrayValue(1,[500,500],c,"int",-1)
    a.addNode(b)
    return a
    
def test_hlwritenodelist():
    szcomprlist = generate_szlib_compritem_nodelist()
    zcomprlist = generate_zlib_compritem_nodelist()
    notcomprlist = generate_notcompritem_nodelist()

    fcprop = _pyhl.filecreationproperty()

    #print "USING ZLIB COMPRESSION"
    zcomprlist.write("hlwrite_zlibcompressed.hdf")

    #print "USING SZLIB COMPRESSION"
    szcomprlist.write("hlwrite_szlibcompressed.hdf")

    #print "USING FC PROPERTY"
    notcomprlist.write("hlwrite_filecreationprop.hdf",fcprop)

    #print "USING ZLIB AND FC PROPERTY"
    zcomprlist.write("hlwrite_zlibandfilecreationprop.hdf",fcprop)

    #print "USING SZLIB AND FC PROPERTY"
    szcomprlist.write("hlwrite_szlibandfilecreationprop.hdf",fcprop)

    #print "USING STANDARD OLD ZLIB COMPRESSION"
    notcomprlist.write("hlwriteold_compr6.hdf",6);

    #print "USING STANDARD OLD ZLIB DEFAULT COMPRESSION"
    notcomprlist.write("hlwriteold_defaultcompr.hdf")

    #print "USING STANDARD OLD ZLIB 0 COMPRESSION"
    notcomprlist.write("hlwriteold_0compr.hdf")

    #del zcomprlist
    #del szcomprlist
    #del notcomprlist

def get_noaa17_channel2():
    a=_pyhl.read_nodelist("noaa17_20040317_2048_08992.sswe.avhrr.hdf")
    a.selectNode("/channel2")
    a.fetch()
    b=a.getNode("/channel2")
    return b

def test_various_noaa_compressions():
    b=get_noaa17_channel2()

    dims=b.dims()
    data=b.data()
    fmt=b.format()

    zcompr = _pyhl.compression(_pyhl.COMPRESSION_ZLIB)
    zcompr.level=6
    szcompr = _pyhl.compression(_pyhl.COMPRESSION_SZLIB)
    szcompr.szlib_px_per_block=16
    fcprop = _pyhl.filecreationproperty()

    # Create the ZLIB compression nodelist
    zlcompr =_pyhl.nodelist()
    nb = _pyhl.node(_pyhl.DATASET_ID,"/data",zcompr)
    nb.setArrayValue(1,dims,data,fmt,-1)
    zlcompr.addNode(nb)

    # Create the SZLIB compression nodelist
    szlcompr = _pyhl.nodelist()
    nb = _pyhl.node(_pyhl.DATASET_ID,"/data",szcompr)
    nb.setArrayValue(1,dims,data,fmt,-1)
    szlcompr.addNode(nb)

    # Create the nodelist without compression
    nocompr = _pyhl.nodelist()
    nb = _pyhl.node(_pyhl.DATASET_ID,"/data")
    nb.setArrayValue(1,dims,data,fmt,-1)
    nocompr.addNode(nb)

    zlcompr.write("hlwrite_noaa17_zlib.hdf")
    szlcompr.write("hlwrite_noaa17_szlib.hdf")
    nocompr.write("hlwrite_noaa17_nocompr.hdf")
    zlcompr.write("hlwrite_noaa17_zlib_fcp.hdf",fcprop)
    szlcompr.write("hlwrite_noaa17_szlib_fcp.hdf",fcprop)
    nocompr.write("hlwrite_noaa17_nocompr_fcp.hdf",fcprop)
    nocompr.write("hlwrite_noaa17_nocompr6.hdf",6)
    nocompr.write("hlwrite_noaa17_nocompr0.hdf",0)
    
def test_buggyfcprop():
    zcomprlist = generate_zlib_compritem_nodelist()

    fcprop = _pyhl.filecreationproperty()

    fcprop.sizes=(4,4)

    zcomprlist.write("hlwrite_buggyfcprop.hdf",fcprop)
    

if __name__=="__main__":
    #for i in range(0,1000):
    #    print "Iteration ",i
    #    test_hlwritenodelist()


    #test_various_noaa_compressions()
    test_buggyfcprop()
